%% Read CRS-matrix from Aurel
clear
clc

%%
name = 'TBC2_mat.bin';
name = 'try.bin'
fileID = fopen(name);

%%
nrow = fread(fileID, 1, 'int');          % number of columns
nnz  = fread(fileID, 1, 'int');          % number of non-zero elements/blocks
ndof = fread(fileID, 1, 'int')/nnz;      % degrees of freedom per block

%%
inz = fread(fileID, nrow, 'int');         % number of elements per row
icol = fread(fileID, nnz, 'int');         % column indices of non-zero entries
icol = icol+1;                            % C-Index --> Matlab-Index

val = fread(fileID, nnz*ndof, 'double'); % values of non-zero entries

%%      derive koordinate format (irow,icol,val)
irow(nnz,1) = -1;
ij_end = 1;
for k=1:nrow
    ij_begin = ij_end;
    ij_end = ij_begin+inz(k);
    irow(ij_begin:ij_end-1,1) = k;
end

%%  convert to MATLAB sparse format

% S = sparse(irow,icol,val);
S = sparse(icol,irow,val);              % our input data are rowise, Matlab needs columnwise

disp([' Size ',num2str(size(S))])
disp([' Rank ',num2str(sprank(S))])

%% play

spy(S);
S2 = S';
diff = S-S2;
[ii,jj,ss] = find(diff);

if  min(abs(ss)) < 1e-12
    disp('Matrix is symmetric');
end

% isequal(S,S.')
% kappa = condest(S) 
% lambda=eigs(S)

cc=input('Taste druecken');

