%%  Generates a sparse matrix and writes it to a binary file
clear; clc; 
NAME = 'try.bin';             % name of binary file

%% generate an example
A = gallery('poisson',20);
ndof = 1;                     % ~1  ==> extend 'val' appropriately 

spy(A)

% s = nonzeros(A);
% [irow,icol,val] = find(A);    % koordinate format (irow,icol,val), that's column wise
[icol,irow,val] = find(A);    % koordinate format (irow,icol,val), we will need ot rowise
nrow = size(A,1);             % number of rows of square matrix
nnzA = nnz(A);                % number of nonzero elements in Matrix
if size(A,1)~=size(A,2)
    disp('Matrix is not symmetric')
end
    
%%      derive CRS format (cnt,icol,val) from koordinate format (irow,icol,val)
%       assumes that elements from one row are stored successively

tmp = unique(irow);
cnt = hist(irow,tmp);         % number of elements per row
icol = icol-1;                % Matlab-Index --> C-Index

% In case that the displacement is required (disp,icol,val)
disp = [0 cumsum(cnt) ];      % C-Index : size(disp) == nrow+1  !

%% Write CRS to binary file
fileID = fopen(NAME,'w');


%fwrite(fileID,A,'integer*4');

fwrite(fileID, nrow, 'int');          % number of columns
fwrite(fileID, nnzA, 'int');          % number of non-zero elements/blocks
fwrite(fileID, nnzA*ndof, 'int');     %         * degrees of freedom per block

%%
fwrite(fileID, cnt, 'int');     % number of elements per row
fwrite(fileID, icol, 'int');    % column indices of non-zero entries
fwrite(fileID, val, 'double');  % values of non-zero entries

